import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Stack;
import java.util.Vector;


public class GraphADT<T extends Comparable<T>> {
  AdjacencyMatrix<T> theMatrix;
  ArrayList<T> nodes;
  int numNodes;
  
  /**
   * constructor for GraphADT. 
   * @param n - int. number of nodes (initial)
   */
  public GraphADT(int n){
	  //given
	  numNodes = n;
	  nodes = new ArrayList<T>(numNodes);
  }
  /**
   * Add a node to the graph
   * @param in - type T, the node's data
   */
  public void addNode(T in){
	  //given
	  nodes.add(in);
  }
  /**
   * makes the graph's adjacency matrix. 
   * must be run AFTER adding all the nodes but BEFORE doing anything else like adding 
   * edges or traversing
   */
  public void makeMatrix(){
	  //given, run once all nodes have been added
	  theMatrix = new AdjacencyMatrix<T>(nodes);
  }
  /**
   * adds an edge to the graph
   * @param from - T, the start node
   * @param to - T, the ending node
   * @param weight - int, this edge's weight (1 if graph not weighted)
   */
  public void addEdge(T from, T to, int weight){
	  //rows = from, columns = to
	  //needs implementation
  }
  /**
   * adds an edges to the graph, assumes weight 1
   * @param from - T, the start node
   * @param to - T, the end node
   */
  public void addEdge(T from, T to){
	  //rows = from, columns = to, weight = 1
	  //call other addEdge method
	  //needs implementation
  }
  /**
   * Depth First Search. Actually, it should traverse the whole graph using the DFS algorithm
   * @param start - T, the node to start at
   * @return Vector<T>, list of the nodes that were visited in the order they were visited
   */
  public Vector<T> DFS(T start){
	  //needs implementation

  }
  /**
   * Breadth First Search. Actually, it should traverse the whole graph using the BFS algorithm
   * @param start - T, the node to start at
   * @return Vector<T>, list of the nodes that were visited in the order they were visited
   */
  public Vector<T> BFS(T start){
	  //needs implementation

  }
  /**
   * prints the graph's adjacency matrix
   */
  public void printMatrix(){
	  //given
	  System.out.println(theMatrix);
  }
  /**
   * returns string representation of the graph, for printing
   */
  public String toString(){
	  //given
	  String out = "Graph ADT. Adjacency matrix: \n";
	  out += theMatrix.toString();
	  out += "\n";
	  return out;
  }
  /**
   * prints the graph is a format suitable for drawing with the Graphviz package (a.k.a. dot and 
   * similar programs) recommended drawing method:
   *    terminal> sfdp -Tpng cities.dot -o cities.png
   * where cities.dot store copy-pasted output from this method, and cities.png is output file.
   * sfdp is better than dot for this sort of drawing
   */
  public void printDot(){
	  //given
	  System.out.println("\ngraph cities{");
	  T current = null;
	  for(int i = 0; i < nodes.size(); i++){
		  current = nodes.get(i);
		  Vector<Integer> adjacent = theMatrix.getRow(current);
		  for(int j = 0; j < adjacent.size(); j++){
			  if(adjacent.get(j) > 0){
				  System.out.println("   "+current+" -- "+nodes.get(j));
			  }
		  }
	  }
	  System.out.println("}");
  }
}
